package cn.iocoder.yudao.module.delivery.service.Impl;

import cn.iocoder.yudao.framework.common.util.json.JsonUtils;
import cn.iocoder.yudao.module.delivery.entity.*;
import cn.iocoder.yudao.module.delivery.mapper.EmployeeMapper;
import cn.iocoder.yudao.module.delivery.mapper.SalesReportMapper;
import cn.iocoder.yudao.module.delivery.service.SalesReportService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.time.YearMonth;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/*
  销售看板统计报表
  lanbm 2024-04-01 add
 */
@Service("SalesReportService")
public class SalesReportImpl implements SalesReportService {

    @Autowired
    private SalesReportMapper salesReportMapper;


    public List<SalesReportRespShow> SalesReportCount(SalesReportReq Req) {
        Req = getReq(Req);

        //String jsonStr = JsonUtils.toJsonString(Req);
        //JsonUtils.SaveLog(jsonStr);

        //当前数据
        SalesReportReq ReqCur = Req;
        //对比数据
        SalesReportReq ReqLast = getReqTb(Req);

        List<SalesReportRespShow> listResult = new ArrayList<>();
        SalesReportResp Resp = salesReportMapper.SalesReportCount(ReqCur);
        SalesReportResp RespLast = salesReportMapper.SalesReportCount(ReqLast);

        //总值
        SalesReportRespShow all = new SalesReportRespShow();
        if (Resp.getAllsumvolume() == null ||
                Resp.getAllsumvolume().compareTo(BigDecimal.ZERO) == 0
        ) {
            all.setSumAll(new BigDecimal(0));
        } else {
            all.setSumAll(Resp.getAllsumvolume());
        }

        if (RespLast.getAllsumvolume() == null ||
                RespLast.getAllsumvolume().compareTo(BigDecimal.ZERO) == 0) {
            all.setSumAllTb(new BigDecimal(0));
        } else {
            all.setSumAllTb(RespLast.getAllsumvolume());
        }

        String sTemp = "";
        if (RespLast.getAllsumvolume() == null ||
                RespLast.getAllsumvolume().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(RespLast.getAllsumvolume().subtract(Resp.getAllsumvolume()),
                    Resp.getAllsumvolume());
        }
        all.setTbShow(sTemp);


        //海运拼柜
        SalesReportRespShow all1 = new SalesReportRespShow();
        all1.setSumAll(Resp.getSumvolume1());
        all1.setSumAllTb(RespLast.getSumvolume1());
        if (RespLast.getSumvolume1() == null ||
                RespLast.getSumvolume1().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(RespLast.getSumvolume1().subtract(Resp.getSumvolume1()),
                    Resp.getSumvolume1());
        }
        all1.setTbShow(sTemp);


        //专线空运
        SalesReportRespShow all3 = new SalesReportRespShow();
        if (Resp.getSumweight3() == null ||
                RespLast.getSumweight3().compareTo(BigDecimal.ZERO) == 0) {
            all3.setSumAll(new BigDecimal(0));
        } else {
            all3.setSumAll(Resp.getSumweight3());
        }

        if (RespLast.getSumweight3() == null ||
                RespLast.getSumweight3().compareTo(BigDecimal.ZERO) == 0) {
            all3.setSumAllTb(new BigDecimal(0));
        } else {
            all3.setSumAllTb(RespLast.getSumweight3());
        }
        if (RespLast.getSumweight3() == null ||
                RespLast.getSumweight3().compareTo(BigDecimal.ZERO) == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(RespLast.getSumweight3().subtract(Resp.getSumweight3()),
                    Resp.getSumweight3());
        }
        all3.setTbShow(sTemp);

        listResult.add(all);
        listResult.add(all1);
        listResult.add(all3);
        return listResult;
    }

    /*
     获取首次成交统计数据 lanbm 2024-05-09 add
     */
    public SalesReportCusTarget FirstCustomerCount(SalesReportReq Req) {
        Req = getReq(Req);
        //String jsonStr = JsonUtils.toJsonString(Req);
        //JsonUtils.SaveLog(jsonStr);

        //当前数据
        SalesReportReq ReqCur = Req;
        //对比数据
        SalesReportReq ReqLast = getReqTb(Req);

        SalesReportCusTarget objResult = new SalesReportCusTarget();
        int nR = salesReportMapper.FirstCustomerCount(ReqCur);
        int nRTb = salesReportMapper.FirstCustomerCount(ReqLast);
        String sTemp = "";
        if (nRTb == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(new BigDecimal(nR - nRTb), new BigDecimal(nRTb));
        }
        objResult.setTbShow(sTemp);
        return objResult;
    }

    /*
     根据查询参数获取同比查询参数 lanbm 2024-05-09 add
     */
    private SalesReportReq getReqTb(SalesReportReq Req) {
        SalesReportReq ReqLast = new SalesReportReq();
        ReqLast.setSDate(Req.getSDuiBiDate());
        ReqLast.setEDate(Req.getEDuiBiDate());
        ReqLast.setCurYear(Req.getDuibiYear());
        ReqLast.setDeptid(Req.getDeptid());
        ReqLast.setSalesmanid(Req.getSalesmanid());
        return ReqLast;
    }


    /*
    统计一段时间内客户成交数目，出重客户
    lanbm 2024-05-09 add
    */
    public SalesReportCusTarget CustomerTargetCount(SalesReportReq Req) {
        Req = getReq(Req);
        //String jsonStr = JsonUtils.toJsonString(Req);
        //JsonUtils.SaveLog(jsonStr);

        //当前数据
        SalesReportReq ReqCur = Req;
        //对比数据
        SalesReportReq ReqLast = getReqTb(Req);

        SalesReportCusTarget objResult = new SalesReportCusTarget();
        int nR = salesReportMapper.CustomerTargetCount(Req);
        int nRTb = salesReportMapper.CustomerTargetCount(ReqLast);
        String sTemp = "";
        if (nRTb == 0) {
            sTemp = "同期值为0";
        } else {
            sTemp = getPercentage(new BigDecimal(nR - nRTb), new BigDecimal(nRTb));
        }
        objResult.setTbShow(sTemp);
        return objResult;
    }

    /*
   格式化BigDecimal为字符串，保留两位小数
   lanbm 2024-04-10 add
   */
    private String format(BigDecimal value) {
        NumberFormat numberFormat = NumberFormat.getInstance();
        numberFormat.setMinimumFractionDigits(2);
        numberFormat.setMaximumFractionDigits(2);
        return numberFormat.format(value.doubleValue());
    }

    /*
    计算百分比
    lanbm 2024-04-10 add
    */
    private String getPercentage(BigDecimal part, BigDecimal total) {
        BigDecimal percentage = part.divide(total, 5,
                BigDecimal.ROUND_HALF_UP).multiply(new BigDecimal("100"));
        // 输出百分比
        String sR = format(percentage) + "%";
        return sR;
    }

    private String getCurDate() {
        Date date = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String currentDate = sdf.format(date);
        return currentDate;
    }

    private int getCurYear() {
        Calendar calendar = Calendar.getInstance();
        int year = calendar.get(Calendar.YEAR);
        return year;
    }

    /*
     获取某年某月的最后一天 lanbm 2024-04-16 add
     */
    private int getLastDay(int year, int month) {
        YearMonth yearMonth = YearMonth.of(year, month);
        int lastDay = yearMonth.lengthOfMonth();
        return lastDay;
    }

    /*
     对查询日期做初始化处理 lanbm 2024-05-09 add
     */
    private SalesReportReq getReq(SalesReportReq Req) {
        int y = getCurYear();
        if (Req.getDuibiYear() == null) {
            Req.setDuibiYear(String.valueOf(y - 1));
        }

        if (Req.getSDate() == null) {
            Req.setCurYear(String.valueOf(y));
            Req.setSDate(String.valueOf(y) + "-01-01");
            Req.setSDuiBiDate(Req.getDuibiYear() + "-01-01");

        } else {
            //2024-03
            String sT = Req.getSDate();
            Req.setSDate(sT + "-01");

            String s = sT.substring(5, 7);
            Req.setSDuiBiDate(Req.getDuibiYear() + "-" + s + "-01");

            Req.setCurYear(sT.substring(0, 4));
        }

        if (Req.getEDate() == null) {
            Req.setEDate(getCurDate());

            String s = Req.getEDate().substring(5, 7);
            int lastDay = getLastDay(Integer.parseInt(Req.getDuibiYear()), Integer.parseInt(s));
            Req.setEDuiBiDate(Req.getDuibiYear() + "-" + s + "-" + String.valueOf(lastDay));

        } else {
            String sE = Req.getEDate();
            String sY = sE.substring(0, 4);
            String s = sE.substring(5, 7);
            int lastDay = getLastDay(Integer.parseInt(sY), Integer.parseInt(s));
            Req.setEDate(sE + "-" + String.valueOf(lastDay));

            lastDay = getLastDay(Integer.parseInt(Req.getDuibiYear()), Integer.parseInt(s));
            Req.setEDuiBiDate(Req.getDuibiYear() + "-" + s + "-" + String.valueOf(lastDay));
        }
        return Req;
    }

}
